/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.provider;


import edu.kit.ipd.descartes.core.provider.EntityItemProvider;

import edu.kit.ipd.descartes.mm.adaptation.AdaptationFactory;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AdaptationProcessItemProvider
    extends EntityItemProvider
    implements
        IEditingDomainItemProvider,
        IStructuredItemContentProvider,
        ITreeItemContentProvider,
        IItemLabelProvider,
        IItemPropertySource {
    /**
     * This constructs an instance from a factory and a notifier.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AdaptationProcessItemProvider(AdapterFactory adapterFactory) {
        super(adapterFactory);
    }

    /**
     * This returns the property descriptors for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
        if (itemPropertyDescriptors == null) {
            super.getPropertyDescriptors(object);

        }
        return itemPropertyDescriptors;
    }

    /**
     * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
     * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
     * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
        if (childrenFeatures == null) {
            super.getChildrenFeatures(object);
            childrenFeatures.add(AdaptationPackage.Literals.ADAPTATION_PROCESS__TACTICS);
            childrenFeatures.add(AdaptationPackage.Literals.ADAPTATION_PROCESS__ACTIONS);
            childrenFeatures.add(AdaptationPackage.Literals.ADAPTATION_PROCESS__STRATEGIES);
            childrenFeatures.add(AdaptationPackage.Literals.ADAPTATION_PROCESS__PARAMETERS);
            childrenFeatures.add(AdaptationPackage.Literals.ADAPTATION_PROCESS__GOAL);
        }
        return childrenFeatures;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected EStructuralFeature getChildFeature(Object object, Object child) {
        // Check the type of the specified child object and return the proper feature to use for
        // adding (see {@link AddCommand}) it as a child.

        return super.getChildFeature(object, child);
    }

    /**
     * This returns AdaptationProcess.gif.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object getImage(Object object) {
        return overlayImage(object, getResourceLocator().getImage("full/obj16/AdaptationProcess"));
    }

    /**
     * This returns the label text for the adapted class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public String getText(Object object) {
        String label = ((AdaptationProcess)object).getName();
        return label == null || label.length() == 0 ?
            getString("_UI_AdaptationProcess_type") :
            getString("_UI_AdaptationProcess_type") + " " + label;
    }

    /**
     * This handles model notifications by calling {@link #updateChildren} to update any cached
     * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public void notifyChanged(Notification notification) {
        updateChildren(notification);

        switch (notification.getFeatureID(AdaptationProcess.class)) {
            case AdaptationPackage.ADAPTATION_PROCESS__TACTICS:
            case AdaptationPackage.ADAPTATION_PROCESS__ACTIONS:
            case AdaptationPackage.ADAPTATION_PROCESS__STRATEGIES:
            case AdaptationPackage.ADAPTATION_PROCESS__PARAMETERS:
            case AdaptationPackage.ADAPTATION_PROCESS__GOAL:
                fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
                return;
        }
        super.notifyChanged(notification);
    }

    /**
     * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
     * that can be created under this object.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
        super.collectNewChildDescriptors(newChildDescriptors, object);

        newChildDescriptors.add
            (createChildParameter
                (AdaptationPackage.Literals.ADAPTATION_PROCESS__TACTICS,
                 AdaptationFactory.eINSTANCE.createTactic()));

        newChildDescriptors.add
            (createChildParameter
                (AdaptationPackage.Literals.ADAPTATION_PROCESS__ACTIONS,
                 AdaptationFactory.eINSTANCE.createAction()));

        newChildDescriptors.add
            (createChildParameter
                (AdaptationPackage.Literals.ADAPTATION_PROCESS__STRATEGIES,
                 AdaptationFactory.eINSTANCE.createStrategy()));

        newChildDescriptors.add
            (createChildParameter
                (AdaptationPackage.Literals.ADAPTATION_PROCESS__PARAMETERS,
                 AdaptationFactory.eINSTANCE.createParameter()));

        newChildDescriptors.add
            (createChildParameter
                (AdaptationPackage.Literals.ADAPTATION_PROCESS__GOAL,
                 AdaptationFactory.eINSTANCE.createOverallGoal()));
    }

    /**
     * Return the resource locator for this item provider's resources.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
        return AdaptationEditPlugin.INSTANCE;
    }

}
