/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptationpoints.provider;

import edu.kit.ipd.descartes.mm.adaptationpoints.util.AdaptationpointsAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class AdaptationpointsItemProviderAdapterFactory extends AdaptationpointsAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
    /**
     * This keeps track of the root adapter factory that delegates to this adapter factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected Collection<Object> supportedTypes = new ArrayList<Object>();

    /**
     * This constructs an instance.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public AdaptationpointsItemProviderAdapterFactory() {
        supportedTypes.add(IEditingDomainItemProvider.class);
        supportedTypes.add(IStructuredItemContentProvider.class);
        supportedTypes.add(ITreeItemContentProvider.class);
        supportedTypes.add(IItemLabelProvider.class);
        supportedTypes.add(IItemPropertySource.class);
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPointDescriptions} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected AdaptationPointDescriptionsItemProvider adaptationPointDescriptionsItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptationpoints.AdaptationPointDescriptions}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createAdaptationPointDescriptionsAdapter() {
        if (adaptationPointDescriptionsItemProvider == null) {
            adaptationPointDescriptionsItemProvider = new AdaptationPointDescriptionsItemProvider(this);
        }

        return adaptationPointDescriptionsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ModelVariableConfigurationRangeItemProvider modelVariableConfigurationRangeItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelVariableConfigurationRange}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createModelVariableConfigurationRangeAdapter() {
        if (modelVariableConfigurationRangeItemProvider == null) {
            modelVariableConfigurationRangeItemProvider = new ModelVariableConfigurationRangeItemProvider(this);
        }

        return modelVariableConfigurationRangeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelEntityConfigurationRange} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected ModelEntityConfigurationRangeItemProvider modelEntityConfigurationRangeItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptationpoints.ModelEntityConfigurationRange}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createModelEntityConfigurationRangeAdapter() {
        if (modelEntityConfigurationRangeItemProvider == null) {
            modelEntityConfigurationRangeItemProvider = new ModelEntityConfigurationRangeItemProvider(this);
        }

        return modelEntityConfigurationRangeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected PropertyRangeItemProvider propertyRangeItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptationpoints.PropertyRange}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createPropertyRangeAdapter() {
        if (propertyRangeItemProvider == null) {
            propertyRangeItemProvider = new PropertyRangeItemProvider(this);
        }

        return propertyRangeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected SetOfConfigurationsItemProvider setOfConfigurationsItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptationpoints.SetOfConfigurations}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createSetOfConfigurationsAdapter() {
        if (setOfConfigurationsItemProvider == null) {
            setOfConfigurationsItemProvider = new SetOfConfigurationsItemProvider(this);
        }

        return setOfConfigurationsItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all {@link edu.kit.ipd.descartes.mm.adaptationpoints.OclConstraint} instances.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    protected OclConstraintItemProvider oclConstraintItemProvider;

    /**
     * This creates an adapter for a {@link edu.kit.ipd.descartes.mm.adaptationpoints.OclConstraint}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter createOclConstraintAdapter() {
        if (oclConstraintItemProvider == null) {
            oclConstraintItemProvider = new OclConstraintItemProvider(this);
        }

        return oclConstraintItemProvider;
    }

    /**
     * This returns the root adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public ComposeableAdapterFactory getRootAdapterFactory() {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object type) {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the adapter.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Adapter adapt(Notifier notifier, Object type) {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    @Override
    public Object adapt(Object object, Object type) {
        if (isFactoryForType(type)) {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void addListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void removeListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void fireNotifyChanged(Notification notification) {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null) {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This disposes all of the item providers created by this factory. 
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    public void dispose() {
        if (adaptationPointDescriptionsItemProvider != null) adaptationPointDescriptionsItemProvider.dispose();
        if (modelVariableConfigurationRangeItemProvider != null) modelVariableConfigurationRangeItemProvider.dispose();
        if (modelEntityConfigurationRangeItemProvider != null) modelEntityConfigurationRangeItemProvider.dispose();
        if (propertyRangeItemProvider != null) propertyRangeItemProvider.dispose();
        if (setOfConfigurationsItemProvider != null) setOfConfigurationsItemProvider.dispose();
        if (oclConstraintItemProvider != null) oclConstraintItemProvider.dispose();
    }

}
