/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.functions.provider;


import edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression;
import edu.kit.ipd.descartes.mm.applicationlevel.functions.BooleanOperation;
import edu.kit.ipd.descartes.mm.applicationlevel.functions.FunctionsFactory;
import edu.kit.ipd.descartes.mm.applicationlevel.functions.FunctionsPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link edu.kit.ipd.descartes.mm.applicationlevel.functions.BinaryBooleanExpression} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class BinaryBooleanExpressionItemProvider
	extends ExpressionItemProvider
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BinaryBooleanExpressionItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addOperationPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Operation feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addOperationPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_BinaryBooleanExpression_operation_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_BinaryBooleanExpression_operation_feature", "_UI_BinaryBooleanExpression_type"),
				 FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__OPERATION,
				 true,
				 false,
				 false,
				 ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT);
			childrenFeatures.add(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns BinaryBooleanExpression.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/BinaryBooleanExpression"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		BooleanOperation labelValue = ((BinaryBooleanExpression)object).getOperation();
		String label = labelValue == null ? null : labelValue.toString();
		return label == null || label.length() == 0 ?
			getString("_UI_BinaryBooleanExpression_type") :
			getString("_UI_BinaryBooleanExpression_type") + " " + label;
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(BinaryBooleanExpression.class)) {
			case FunctionsPackage.BINARY_BOOLEAN_EXPRESSION__OPERATION:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
				return;
			case FunctionsPackage.BINARY_BOOLEAN_EXPRESSION__LEFT:
			case FunctionsPackage.BINARY_BOOLEAN_EXPRESSION__RIGHT:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createFormalParameter()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createIntLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createDoubleLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createIfElseExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createBinaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createUnaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createComparison()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createTerm()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createProduct()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createPower()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createProbabilityMassFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createBoxedPDF()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createNormalDistribution()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT,
				 FunctionsFactory.eINSTANCE.createExponentialDistribution()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createFormalParameter()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createIntLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createDoubleLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createIfElseExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createBinaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createUnaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createComparison()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createTerm()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createProduct()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createPower()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createProbabilityMassFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createBoxedPDF()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createNormalDistribution()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT,
				 FunctionsFactory.eINSTANCE.createExponentialDistribution()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__LEFT ||
			childFeature == FunctionsPackage.Literals.BINARY_BOOLEAN_EXPRESSION__RIGHT;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}
