/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.functions.provider;


import edu.kit.ipd.descartes.mm.applicationlevel.functions.FunctionsFactory;
import edu.kit.ipd.descartes.mm.applicationlevel.functions.FunctionsPackage;
import edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link edu.kit.ipd.descartes.mm.applicationlevel.functions.IfElseExpression} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class IfElseExpressionItemProvider
	extends ExpressionItemProvider
	implements
		IEditingDomainItemProvider,
		IStructuredItemContentProvider,
		ITreeItemContentProvider,
		IItemLabelProvider,
		IItemPropertySource {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IfElseExpressionItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

		}
		return itemPropertyDescriptors;
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION);
			childrenFeatures.add(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP);
			childrenFeatures.add(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns IfElseExpression.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/IfElseExpression"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		return getString("_UI_IfElseExpression_type");
	}

	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(IfElseExpression.class)) {
			case FunctionsPackage.IF_ELSE_EXPRESSION__CONDITION:
			case FunctionsPackage.IF_ELSE_EXPRESSION__TRUE_EXP:
			case FunctionsPackage.IF_ELSE_EXPRESSION__FALSE_EXP:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createFormalParameter()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createIntLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createDoubleLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createIfElseExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createBinaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createUnaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createComparison()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createTerm()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createProduct()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createPower()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createProbabilityMassFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createBoxedPDF()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createNormalDistribution()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION,
				 FunctionsFactory.eINSTANCE.createExponentialDistribution()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createFormalParameter()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createIntLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createDoubleLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createIfElseExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createBinaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createUnaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createComparison()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createTerm()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createProduct()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createPower()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createProbabilityMassFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createBoxedPDF()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createNormalDistribution()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP,
				 FunctionsFactory.eINSTANCE.createExponentialDistribution()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createFormalParameter()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createBooleanLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createIntLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createDoubleLiteral()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createIfElseExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createBinaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createUnaryBooleanExpression()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createComparison()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createTerm()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createProduct()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createPower()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createProbabilityMassFunction()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createBoxedPDF()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createNormalDistribution()));

		newChildDescriptors.add
			(createChildParameter
				(FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP,
				 FunctionsFactory.eINSTANCE.createExponentialDistribution()));
	}

	/**
	 * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection) {
		Object childFeature = feature;
		Object childObject = child;

		boolean qualify =
			childFeature == FunctionsPackage.Literals.IF_ELSE_EXPRESSION__CONDITION ||
			childFeature == FunctionsPackage.Literals.IF_ELSE_EXPRESSION__TRUE_EXP ||
			childFeature == FunctionsPackage.Literals.IF_ELSE_EXPRESSION__FALSE_EXP;

		if (qualify) {
			return getString
				("_UI_CreateChild_text2",
				 new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
		}
		return super.getCreateChildText(owner, feature, child, selection);
	}

}
